// UVa 177
// On stocke l'affichage dans un tableau, initialement rempli d'espaces.
// On a d'abord calcul (par une version initiale du programme) la taille
// ncessaire du tableau.
// On reprsente un pliage par une suite de "virages" gauche ou droite
// (par ex GGD pour N=2). On la calcule rcursivement. Puis on parcours
// cette suite en modifiant le tableau d'affichage de manire approprie.

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define L 230 // largeur suffisante pour N=13
#define H 140 // hauteur suffisante pour N=13
#define DEC_Y --y; if (y<hmin) hmin=y;
#define DEC_X --x; if (x<lmin) lmin=x;
#define INC_Y ++y; if (y>hmax) hmax=y;
#define INC_X ++x; if (x>lmax) lmax=x;
#define AFF_H if (b) affichage[hmax-y][x-lmin]='_';
#define AFF_V if (b) affichage[hmax-y][x-lmin]='|';

int mouvements[8192]; // 0=gauche, 1=droite
int lmin, lmax, hmin, hmax;
char affichage[H][L];
int maximums[H]; // position max atteinte sur chaque ligne

int folding(int n)
{
  if (n==1)
    {
      mouvements[0] = 0;
      return 1;
    }

  int k;

  k = folding(n-1);
  mouvements[k]=0;
  for (int i=0;i<k;++i)
    mouvements[k+i+1]=1-mouvements[k-i-1];
  return (2*k+1);

}

void parcours(int n, bool b)
{
  int ancienne_direction=0; // 0=droite, 1=haut, 2=gauche, 3=bas
  int nouvelle_direction; // 0=droite, 1=haut, 2=gauche, 3=bas
  int x=0, y=0; // position en cours

  for (int i=0; i<n; ++i)
    {
      nouvelle_direction = (ancienne_direction+5-2*mouvements[i])%4;
      if (b && x-lmin>maximums[hmax-y]) maximums[hmax-y]=x-lmin;
      switch(ancienne_direction)
	{
	case 0:
	  AFF_H;
	  INC_X;
	  if (nouvelle_direction==3)
	    {
	      DEC_Y;
	    }
	  break;
	case 1:
	  AFF_V;
	  INC_Y;
	  switch (nouvelle_direction)
	    {
	    case 0: INC_X; break;
	    case 2: DEC_X; break;
	    default: break;
	    }
	  break;
	case 2:
	  AFF_H;
	  DEC_X;
	  if (nouvelle_direction==3)
	    {
	      DEC_Y;
	    }
	  break;
	case 3:
	  AFF_V;
	  switch (nouvelle_direction)
	    {
	    case 0: INC_X; break;
	    case 2: DEC_X; break;
	    default: break;
	    }
	  break;
	default: break;
	}
      ancienne_direction=nouvelle_direction;
    }
  // on a oublie le dernier caractere
  if (b && x-lmin>maximums[hmax-y]) maximums[hmax-y]=x-lmin;
  switch(ancienne_direction)
    {
    case 0:
      AFF_H; break;
    case 1:
      AFF_V; break;
    case 2:
      AFF_H; break;
    case 3:
      AFF_V; break;
    default: break;
    }
}

int main()
{
  int n;
  int k;

  std::cin >> n;

  while (n > 0)
    {
      lmax=0; lmin=0; hmax=0; hmin=0;
      memset(affichage, ' ', L*H*sizeof(char));
      memset(maximums, 0, H*sizeof(int));
      k=folding(n);
      parcours(k, false);
      parcours(k, true);
      for (int i=0; i<=hmax-hmin; ++i)
	{
	  affichage[i][maximums[i]+1] = '\0';
	  puts(affichage[i]);
	}
      std::cout << '^' << std::endl;
      std::cin >> n;
    }
}
